'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

class Handler {

  constructor(replier, sender) {
    this.hasSentReply = false;

    this.replier = replier;
    this.sender = sender;
  }

  handleMessage(message, context) {
    var _this = this;

    return _asyncToGenerator(function* () {
      if (!context) {
        if (_this.intent && _this.intent !== message.intent) {
          return null;
        }
        return _this.handleFirstMessage(message);
      }
      return _this.handleSessionMessage(message, context);
    })();
  }

  handleFirstMessage(message) {
    return _asyncToGenerator(function* () {})();
  }

  handleSessionMessage(message, context) {
    return _asyncToGenerator(function* () {})();
  }

  handleJump(context) {
    return _asyncToGenerator(function* () {})();
  }

  sendReply(reply) {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      _this2.hasSentReply = true;
      yield _this2.replier(reply);
    })();
  }

  jumpTo(_Handler, context) {
    var _this3 = this;

    this.jumper = _asyncToGenerator(function* () {
      const handler = new _Handler(_this3.replier, _this3.sender);
      const newContext = yield handler.handleJump(context);
      return { handler, context: newContext };
    });
  }
}
exports.default = Handler;