'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dispatcher = require('./dispatcher');

var _dispatcher2 = _interopRequireDefault(_dispatcher);

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

class Convo {

  constructor(tester, sender) {
    this.replies = [];

    this.tester = tester;
    this.sender = sender;
    this.tester._messageEvents.on(this.sender, reply => {
      this.replies = this.replies.concat(reply);
    });
  }

  sendMessage(message) {
    var _this = this;

    return _asyncToGenerator(function* () {
      const newBase = { type: 'message', sender: _this.sender
        // $FlowFixMe This is correct type
      };const newMessage = _extends({}, message, newBase);
      yield _this.tester.dispatcher.handleMessage(newMessage);
    })();
  }

  _takeReply() {
    if (!this.replies.length) {
      return null;
    }
    const reply = this.replies[0];
    this.replies = this.replies.slice(1);
    return reply;
  }

  expectReply() {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      const reply = _this2._takeReply();
      if (reply) {
        return reply;
      }
      return new Promise(function (resolve, reject) {
        _this2.tester._messageEvents.once(_this2.sender, function () {
          const reply = _this2._takeReply();
          if (!reply) {
            return reject(new Error('This should never happen'));
          }
          resolve(reply);
        });
      });
    })();
  }
}

class Tester {

  constructor(senderIdGenerator = () => `${Math.floor(Math.random() * 10 ^ 32)}`) {
    var _this3 = this;

    this._messageEvents = new _events2.default();

    this.sender = (() => {
      var _ref = _asyncToGenerator(function* (r, m) {
        return _this3._messageEvents.emit(m.sender, r);
      });

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    })();

    this.dispatcher = new _dispatcher2.default(this.sender);

    this.senderIdGenerator = senderIdGenerator;
  }

  startConversation(sender = this.senderIdGenerator()) {
    return new Convo(this, sender);
  }
}
exports.default = Tester;